ORG	$20000
LOAD	$20000

st:				;  HAWK 1990 ** DEMO PART III **
				;
	bsr	save_all	
	bsR	mt_init
	lea	$dff000,a6	

	lea	deg,a0		;construit la copper_liste qui
	move.w	#152+42,d4		;a chaque ligne fait correspondre
	move.b	#$45,d0		;une valeur a la couleur de texte
construit_copper:		;($dff182).on a ainsi un effet de 
	move.b	d0,(a0)+	;degrade si les valeurs dans le tablau
	move.b	#$e1,(a0)+	;'valdeg' sont jolis et bien calcules
	move.w	#$fffe,(a0)+	;(je n'ais pas eu le temps il faut
	move.l	#$01860000,(a0)+;le faire a la main)
	add.b	#1,d0		;
	dbra	d4,construit_copper

	move.w	#$7fff,$9a(a6)	
	move.w	#$7fff,$96(a6)	

	move.l	#$2C8122C1,$8e(a6)
	move.l	#$003800d0,$92(a6)

	move.l	#COPER,$dff080	;   init et lancement de la copper
	clr.w	$dff088

	move.l	#bt1,d0	; addresse de la memoire ecran ds d0	
	lea	coppSS1,a0 ; et celle de la copper liste
	move.w	d0,6(a0); puis place le premier mot ds copper+6
	swap	d0      ; et le second ds copper+2
	move.w	d0,2(a0); au debut de la copper ,la copper remettra 
			; cette valeur qui sont les pointeurs
			; de la memoire ecran

	move.l	#bt1,d0	
	lea	coppS1,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)

	move.l	#BLANK,d0	
	lea	coppS1B,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)
	move.l	#BLANK,d0	
	lea	coppS2B,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)
	move.l	#BLANK,d0	
	lea	coppS3B,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)


	move.l	#BLANK,d0	
	lea	coppS2,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)

	move.l	#BLANK,d0	
	lea	coppS3,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)

	move.l	#BOBFOND,d0	
	lea	coppD1,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)

	move.l	#BOBFOND+10240,d0	
	lea	coppD2,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)

	move.l	#BOBFOND+20480,d0	
	lea	coppD3,a0
	move.w	d0,6(a0)
	swap	d0      
	move.w	d0,2(a0)
			
	move.l	#irq,$6c	
	move.w	#$20,96(a6)
	
	move.w	#$c010,$9a(a6)	
	move.w	#$83c0,$96(a6)	

atten:				
	btst	#6,$bfe001	
	bne	atten		

	bsr	restore_all	
	moveq	#0,d0		
rts				

irq:
	movem.l	d0-d7/a0-a5,-(sp)	; sauve la pile
	move.w	$dff01c,d0	; test pour savoir si c'est bien 
	and.w	$dff01e,d0	; une interrup.
	btst	#4,d0		; le reste c'est du pipo et il repart.
	beq	fin_irq		;

	bsr	mt_music	; go to routine soundtracker
	bsr	degrade		; go to la routine de scroll du degra

	BSR	CLEAR

	LEA	COORD1,A0
	BSR	COORDONEES

	LEA	COORD2,A0
	BSR	COORDONEES

	LEA	COORD3,A0
	BSR	COORDONEES

	LEA	COORD4,A0
	BSR	COORDONEES

	BSR	BOB

	add.b	#1,nb		; il affiche une lettre de 16 pts ds
	cmp.b	#15,nb		; le coin droit,il scroll 16 point et
 	bne	agac		; il en reaffiche une autre.
	clr.b	nb		;
	
ir2:	move.l	cptr,a0		; + 1 au pointeur du texte
	add.l	#1,a0		;
	move.l	a0,cptr		;

	cmp.l	#fin_texte,a0   ; on regarde si on est a la fin
	bne abab		; du texte 
	move.l	#texte,cptr	;

abab:	clr.l d0
	move.b	(a0),d0
	lea	chars,a0
	lea	bt1+48,a1
	clr.l	d1	

	sub.w	#'A',d0
	lsl.l	#5,d0
	add.l	d0,a0
	move.l	#15,d0
acab:	move.w	(a0)+,0(a1,d1)	; boucle qui affiche la lettre
	add.l	#52,d1		; l'ecran fait 52 points de large
	dbra 	d0,acab		; (c'est la mega ruse )

agac:	bsr 	scr

fini:
	move.w	#$10,$dff09c
fin_irq:	
	movem.l	(sp)+,d0-d7/a0-a5
rte

scr:					;1 transfert blitter=scroll
	move.l	#bt1+48,$dff050		; source = ecran+48 points
	move.l	#bt1+46,$dff054		; dest   = ecran+46 points
	move.w	#0,$dff064		; modulos a zero car pas de 
	move.w	#0,$dff066		; difference de largeur
	move.l	#$f9f00000,$dff040	; decalage de 15 points vers
	move.l	#$ffffffff,$dff044	; la droite.
	move.w	#16*64+20,$dff058	; taille puis lancement


agag:	btst	#14,$dff002		; attend qu'il ais fini
	bne agag			; son transfert
rts
decalage:dc.w	0
debut:dc.w	0
;pour avoir une couleur,il faut connaitre $0RVB 
;R = red B = blue V = vert  chacun de $0 a $f
;EX: $0fff = blanc
;    $0000 = noir
;    $0f00 = rouge
;    $0f0f = panache ou bleu cerise
; il est important que cette table contienne 604 couleurs et se 
; termine par $ffff qui marque la fin de la table.

valdeg:

	dc.w	$0000,$0011,$0022,$0033,$0044,$0055,$0066,$0077
	dc.w	$0088,$0099,$00aa,$00bb,$00cc,$00dd,$00ee,$00ff
	dc.w	$00ff,$00ee,$00dd,$00cc,$00bb,$00aa,$0099,$0088
	dc.w	$0077,$0066,$0055,$0044,$0033,$0022,$0011,$0000

	dc.w	$0000,$0011,$0022,$0033,$0044,$0055,$0066,$0077
	dc.w	$0088,$0099,$00aa,$00bb,$00cc,$00dd,$00ee,$00ff
	dc.w	$00ff,$00ee,$00dd,$00cc,$00bb,$00aa,$0099,$0088
	dc.w	$0077,$0066,$0055,$0044,$0033,$0022,$0011,$0000

	dc.w	$0000,$0011,$0022,$0033,$0044,$0055,$0066,$0077
	dc.w	$0088,$0099,$00aa,$00bb,$00cc,$00dd,$00ee,$00ff
	dc.w	$00ff,$00ee,$00dd,$00cc,$00bb,$00aa,$0099,$0088
	dc.w	$0077,$0066,$0055,$0044,$0033,$0022,$0011,$0000

	dc.w	$0000,$0011,$0022,$0033,$0044,$0055,$0066,$0077
	dc.w	$0088,$0099,$00aa,$00bb,$00cc,$00dd,$00ee,$00ff
	dc.w	$00ff,$00ee,$00dd,$00cc,$00bb,$00aa,$0099,$0088
	dc.w	$0077,$0066,$0055,$0044,$0033,$0022,$0011,$0000

	dc.w	$0400,$0411,$0422,$0433,$0444,$0455,$0466,$0477
	dc.w	$0488,$0499,$04aa,$04bb,$04cc,$04dd,$04ee,$04ff
	dc.w	$04ff,$04ee,$04dd,$04cc,$04bb,$04aa,$0499,$0488
	dc.w	$0477,$0466,$0455,$0444,$0433,$0422,$0411,$0400

	dc.w	$0000,$0000,$0011,$0022,$0033,$0044,$0055,$0066
	dc.w	$0077,$0088,$0099,$00AA,$00BB,$00CC,$00DD,$00EE
	dc.w	$00EE,$00DD,$00CC,$00BB,$00AA,$0099,$0088,$0077
	dc.w	$0066,$0055,$0044,$0033,$0022,$0011,$0000,$0000

	dc.w	$0000,$0000,$0011,$0022,$0033,$0044,$0055,$0066
	dc.w	$0077,$0088,$0099,$00AA,$00BB,$00CC,$00DD,$00EE
	DC.W	$00FF,$00EE,$00DD,$00DD,$00DD,$00DD,$00DD,$00EE
	DC.W	$00FF,$00FF
	dc.w	$00EE,$00DD,$00CC,$00BB,$00AA,$0099,$0088,$0077
	dc.w	$0066,$0055,$0044,$0033,$0022,$0011,$0000,$0000

	dc.w	$0000,$0000,$0011,$0022,$0033,$0044,$0055,$0066
	dc.w	$0077,$0088,$0099,$00AA,$00BB,$00CC,$00DD,$00EE
	dc.w	$00EE,$00DD,$00CC,$00BB,$00AA,$0099,$0088,$0077
	dc.w	$0066,$0055,$0044,$0033,$0022,$0011,$0000,$0000

	dc.w	$0000,$0000,$0011,$0022,$0033,$0044,$0055,$0066
	dc.w	$0177,$0288,$0399,$04AA,$05BB,$06CC,$07DD,$08EE
	dc.w	$08EE,$07DD,$06CC,$05BB,$04AA,$0399,$0288,$0177
	dc.w	$0066,$0055,$0044,$0033,$0022,$0011,$0000,$0000

	dc.w	$0000,$0000,$0000,$0011,$0022,$0033,$0044,$0055
	dc.w	$0066,$0077,$0088,$0099,$00AA,$00BB,$00CC,$00DD
	dc.w	$00EE,$00FF,$00FF,$00FF,$00EE,$00DD,$00CC,$00BB
	dc.w	$00AA,$00BB,$00CC,$00CC,$00DD,$00EE,$00DD,$00DD
	dc.w	$00DD,$00CC,$00BB,$00AA,$0099,$0088,$0077,$0066
	dc.w	$0055,$0044,$0033,$0022,$0011,$0000,$0000,$0000





;	il faut 37 lignes de 8 valeurs chacunes
	dc.w	$ffff
degrade:
	lea	valdeg,a0
	clr.l	d0
	move.w	debut,d0
	add.l	d0,a0
	lea	deg+6,a1
	move.w	#151+42,d4

boucle_degrade:
	
	move.w	(a0)+,d0		
	cmp.w	#$ffff,d0
	bne	suitedeg
	lea	valdeg,a0
	bra	boucle_degrade
	suitedeg:
	move.w	d0,(a1)
	add.l	#8,a1	

dbra	d4,boucle_degrade

	add.w	#2,debut
	cmp.w	#[168+5]*4,debut
	bne	suitedeg1
	move.w	#0,debut

	suitedeg1:


rts
SWITCH:DC.W	1

COORD1:dc.w	0,0,0,0
COORD2:dc.w	0,0,20,50
COORD3:dc.w	0,0,40,100
COORD4:dc.w	0,0,60,150

COORDONEES:

	ADD.W	#2,4(A0)
	MOVE.W	4(A0),D0

	LEA	SIN,A2
	MOVE.W	(A2,D0.W),D1

	CMP.W	#$FFFF,D1
	BNE	CCCC
	MOVE.W	#0,4(A0)
	BRA	COORDONEES

CCCC:
	MOVE.W	D1,2(A0)
CCC1:

	ADD.W	#2,6(A0)
	MOVE.W	6(A0),D0

	LEA	SIN1,A2
	MOVE.W	(A2,D0.W),D1

	CMP.W	#$FFFF,D1
	BNE	CFIN
	MOVE.W	#0,6(A0)
	BRA	CCC1
CFIN:
	MOVE.W  D1,(A0)

SUITE_COORD:
RTS

CONVERT:			; CONVERTISSEUR COORDONNE CARTESIENNE
				; EN COORDONNE BLITTERIENNE !!!!!!!
	MOVE.W	2(A0),D2
	MULU	#40,D2

	MOVE.W	(A0),D3
	MOVE.W	D3,D1
	AND.W	#$000F,D3

	AND.W	#$FFF0,D1
	DIVU	#8,D1

RTS

BOB01:				; ROUTINE QUI AFFICHE LE BOB AU BLITTER
	BSR	TEST

	move.l	A4,$dff050
	MOVE.L	A4,$DFF04C

	MOVE.L	A6,A5
	ADD.L	D1,A5
	ADD.L	D2,A5

	move.l	A5,$dff054
	MOVE.L	A5,$DFF048

	LSL.W	#8,D3
	LSL.W	#4,D3
	MOVE.W	D3,$DFF042

	OR.W	#$0FCA,D3
	move.W	D3,$dff040

	move.w	#96*64+7,$dff058

BSR	TEST


RTS


SSW:				; ROUTINE QUI MET LE PLAN ACTIF DS
	CMP	#2,SWITCH	; LA COPPER
	BEQ	SSS2

	MOVE.L	#BT1A,D0
	lea	COPP,a1
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	

	MOVE.L	#BT1a+120,D0
	lea	COPP1,a1
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	


	MOVE	#2,SWITCH
	BRA	SSS3
SSS2:

	MOVE.L	#BT1B,D0
	lea	COPP,a1
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	

	MOVE.L	#BT1b+120,D0
	lea	COPP1,a1
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	

	MOVE	#1,SWITCH
SSS3:
RTS

CLEAR:				;ROUTINE KI EFFACE LE PLAN INNACTIF

	CMP	#1,SWITCH
	BNE	CC1

	LEA	BT1A,A2
	BRA	CC2
CC1:
	LEA	BT1B,A2
CC2:

	BSR	TEST

	move.l	a2,$DFF054
	move.w	#$01f0,$DFF040	; destination activee
	move.w	#$0000,$DFF042	; 
	move.w	#0,$DFF074	; remplissage de 0
	clr.w	$DFF066		; modulo=0
	MOVE.W	#200,d0		; nb de lignes a remplir
	lsl.w	#6,d0
	or.w	#20,d0			; nombre de mots de chaque ligne
	move.w	d0,$DFF058		; depart de l'effacement

	BSR	TEST

RTS

TEST:
	BTST	#14,$DFF002
	BNE	TEST
RTS

CHOICE_PLAN:			; CHOISI PLAN ACTIF (OU ON DOIT AFFICHER)
				; L'AUTRE ET EN TRAIN DE S'EFFACER
	CMP	#1,SWITCH	; TECHNIC DU SWAP D'ECRAN !
	BNE	SS1
	LEA	BT1A,A6
	BRA	SS2
SS1:
	LEA	BT1B,A6
SS2:
RTS
SIN:    		; (ENVIRON 160 VALEURS)

DC.W  0,0,0,0,1,1,1,2,3,3,4,5,6,7,8,9,10,11,12,14,15,17,18,20,21,23,25,26
DC.W  28,30,32,34,36,38,40,42,43,45,47,49,51,53,55,57,59,61,63,65,67,69
DC.W  71,73,74,76,78,79,81,83,84,85,87,88,89,91,92,93,94,95,96,96,97,98
DC.W  98,99,99,99,100,100,100,100,100,100,100,99,99,98,98,97,96,96,95,94
DC.W  93,92,91,90,88,87,86,84,83,81,80,78,76,75,73,71,69,67,65,63,62,60
DC.W  58,56,54,52,50,48,46,44,42,40,38,36,34,32,30,28,27,25,23,21,20,18
DC.W  17,15,14,13,11,10,9,8,7,6,5,4,3,3,2,1,1,1,0,0,0,0
DC.W  $FFFF


SIN1:
dc.w 200,200,200,199,199,198,197,196,194,193,191,189,187,185,183,180,177
dc.w 175,172,168,165,162,158,154,150,146,142,138,133,129,124,120,115,110
DC.W 105,100,94,89,84,78,72,67,61,55,50,44,38,32,26,20,14,8,2,4,10,16,22
DC.W 28,34,40,45,51,57,63,68,74,80,85,90,96,101,106,111,116,121,126,130
DC.W 135,139,143,147,151,155,159,163,166,169,172,175,178,181,183,186,188
DC.W 190,192,193,195,196,197,198,199,199,200,200 
DC.W $FFFF


BOB:				; ROUTINE PRICIPALE DU BOB

	move.W	#22,$dff064
	MOVE.W	#22,$DFF062

	MOVE.W	#26,$DFF060
	move.W	#26,$dff066
	move.l	#$FFFF0000,$dff044


	BSR	CHOICE_PLAN

BB:
	BSR	CONVERT



	LEA	COORD4,A0
	BSR	CONVERT		; ORDONNEES DECIMALES EN BLITTER STRING
	LEA	MASK+[96*36],A4
	BSR	BOB01		; AFFICHAGE BOB

	LEA	COORD3,A0
	BSR	CONVERT		
	LEA	MASK+24,A4
	BSR	BOB01		

	LEA	COORD2,A0
	BSR	CONVERT		; ORDONNEES DECIMALES EN BLITTER STRING
	LEA	MASK+12,A4
	BSR	BOB01		; AFFICHAGE BOB

	LEA	COORD1,A0
	BSR	CONVERT		; ORDONNEES DECIMALES EN BLITTER STRING
	LEA	MASK,A4
	BSR	BOB01		; AFFICHAGE BOB


	BSR	SSW		; POUR METTRE PLAN DS COPPER
RTS



save_all:
move.b #%10000111,$bfd100
move.l 4,a6
jsr -132(a6)
move.l $6c,save_vecteur_irq
move.w $dff01c,save_intena
or.w #$c000,save_intena
move.w $dff002,save_dmacon
or.w #$8100,save_dmacon
rts
restore_all:
move.l save_vecteur_irq,$6c
move.w #$7fff,$dff09a
move.w save_intena,$dff09a
move.w #$7fff,$dff096
move.w save_dmacon,$dff096
move.l 4,a6
lea name_glib,a1
moveq #0,d0
jsr -552(a6)
move.l d0,a0
move.l 38(a0),$dff080
clr.w $dff088
move.l d0,a1
jsr -414(a6)
jsr -138(a6)
rts
save_intena:dc.w 0
save_dmacon:dc.w 0
save_vecteur_irq:dc.l 0
name_glib:dc.b "graphics.library",0
even
; -----------------------------------------------
; ------- Soundtracker V2.4 - playroutine -------
; -----------------------------------------------

; call 'mt_init' to initialize the playroutine

mt_init:lea	mt_data,a0
	add.l	#$03b8,a0
	moveq	#$7f,d0
	moveq	#0,d1
mt_init1:
	move.l	d1,d2
	subq.w	#1,d0
mt_init2:
	move.b	(a0)+,d1
	cmp.b	d2,d1
	bgt.s	mt_init1
	dbf	d0,mt_init2
	addq.b	#1,d2

mt_init3:
	lea	mt_data,a0
	lea	mt_sample1(pc),a1
	asl.l	#8,d2
	asl.l	#2,d2
	add.l	#$438,d2
	add.l	a0,d2
	moveq	#$1e,d0
mt_init4:
	move.l	d2,(a1)+
	moveq	#0,d1
	move.w	42(a0),d1
	asl.l	#1,d1
	add.l	d1,d2
	add.l	#$1e,a0
	dbf	d0,mt_init4

	lea	mt_sample1(PC),a0
	moveq	#0,d0
mt_clear:
	move.l	(a0,d0.w),a1
	clr.l	(a1)
	addq.w	#4,d0
	cmp.w	#$7c,d0
	bne.s	mt_clear

	clr.w	$dff0a8
	clr.w	$dff0b8
	clr.w	$dff0c8
	clr.w	$dff0d8
	clr.l	mt_partnrplay
	clr.l	mt_partnote
	clr.l	mt_partpoint

	move.b	mt_data+$3b6,mt_maxpart+1
	rts

; call 'mt_end' to switch the sound off

mt_end:	clr.w	$dff0a8
	clr.w	$dff0b8
	clr.w	$dff0c8
	clr.w	$dff0d8
	move.w	#$f,$dff096
	rts

; the playroutine - call this every frame

mt_music:
	addq.w	#1,mt_counter
mt_cool:cmp.w	#6,mt_counter
	bne.s	mt_notsix
	clr.w	mt_counter
	bra	mt_rout2

mt_notsix:
	lea	mt_aud1temp(PC),a6
	tst.b	3(a6)
	beq.s	mt_arp1
	lea	$dff0a0,a5		
	bsr.s	mt_arprout
mt_arp1:lea	mt_aud2temp(PC),a6
	tst.b	3(a6)
	beq.s	mt_arp2
	lea	$dff0b0,a5
	bsr.s	mt_arprout
mt_arp2:lea	mt_aud3temp(PC),a6
	tst.b	3(a6)
	beq.s	mt_arp3
	lea	$dff0c0,a5
	bsr.s	mt_arprout
mt_arp3:lea	mt_aud4temp(PC),a6
	tst.b	3(a6)
	beq.s	mt_arp4
	lea	$dff0d0,a5
	bra.s	mt_arprout
mt_arp4:rts

mt_arprout:
	move.b	2(a6),d0
	and.b	#$0f,d0
	tst.b	d0
	beq	mt_arpegrt
	cmp.b	#$01,d0
	beq.s	mt_portup
	cmp.b	#$02,d0
	beq.s	mt_portdwn
	cmp.b	#$0a,d0
	beq.s	mt_volslide
	rts

mt_portup:
	moveq	#0,d0
	move.b	3(a6),d0
	sub.w	d0,22(a6)
	cmp.w	#$71,22(a6)
	bpl.s	mt_ok1
	move.w	#$71,22(a6)
mt_ok1:	move.w	22(a6),6(a5)
	rts

mt_portdwn:
	moveq	#0,d0
	move.b	3(a6),d0
	add.w	d0,22(a6)
	cmp.w	#$538,22(a6)
	bmi.s	mt_ok2
	move.w	#$538,22(a6)
mt_ok2:	move.w	22(a6),6(a5)
	rts

mt_volslide:
	moveq	#0,d0
	move.b	3(a6),d0
	lsr.b	#4,d0
	tst.b	d0
	beq.s	mt_voldwn
	add.w	d0,18(a6)
	cmp.w	#64,18(a6)
	bmi.s	mt_ok3
	move.w	#64,18(a6)
mt_ok3:	move.w	18(a6),8(a5)
	rts
mt_voldwn:
	moveq	#0,d0
	move.b	3(a6),d0
	and.b	#$0f,d0
	sub.w	d0,18(a6)
	bpl.s	mt_ok4
	clr.w	18(a6)
mt_ok4:	move.w	18(a6),8(a5)
	rts

mt_arpegrt:
	move.w	mt_counter(PC),d0
	cmp.w	#1,d0
	beq.s	mt_loop2
	cmp.w	#2,d0
	beq.s	mt_loop3
	cmp.w	#3,d0
	beq.s	mt_loop4
	cmp.w	#4,d0
	beq.s	mt_loop2
	cmp.w	#5,d0
	beq.s	mt_loop3
	rts

mt_loop2:
	moveq	#0,d0
	move.b	3(a6),d0
	lsr.b	#4,d0
	bra.s	mt_cont
mt_loop3:
	moveq	#$00,d0
	move.b	3(a6),d0
	and.b	#$0f,d0
	bra.s	mt_cont
mt_loop4:
	move.w	16(a6),d2
	bra.s	mt_endpart
mt_cont:
	add.w	d0,d0
	moveq	#0,d1
	move.w	16(a6),d1
	and.w	#$fff,d1
	lea	mt_arpeggio(PC),a0
mt_loop5:
	move.w	(a0,d0),d2
	cmp.w	(a0),d1
	beq.s	mt_endpart
	addq.l	#2,a0
	bra.s	mt_loop5
mt_endpart:
	move.w	d2,6(a5)
	rts

mt_rout2:
	lea	mt_data,a0
	move.l	a0,a3
	add.l	#$0c,a3
	move.l	a0,a2
	add.l	#$3b8,a2
	add.l	#$43c,a0
	move.l	mt_partnrplay(PC),d0
	moveq	#0,d1
	move.b	(a2,d0),d1
	asl.l	#8,d1
	asl.l	#2,d1
	add.l	mt_partnote(PC),d1
	move.l	d1,mt_partpoint
	clr.w	mt_dmacon

	lea	$dff0a0,a5
	lea	mt_aud1temp(PC),a6
	bsr	mt_playit
	lea	$dff0b0,a5
	lea	mt_aud2temp(PC),a6
	bsr	mt_playit
	lea	$dff0c0,a5
	lea	mt_aud3temp(PC),a6
	bsr	mt_playit
	lea	$dff0d0,a5
	lea	mt_aud4temp(PC),a6
	bsr	mt_playit
	move.w	#$01f4,d0
mt_rls:	dbf	d0,mt_rls

	move.w	#$8000,d0
	or.w	mt_dmacon,d0
	move.w	d0,$dff096

	lea	mt_aud4temp(PC),a6
	cmp.w	#1,14(a6)
	bne.s	mt_voice3
	move.l	10(a6),$dff0d0
	move.w	#1,$dff0d4
mt_voice3:
	lea	mt_aud3temp(PC),a6
	cmp.w	#1,14(a6)
	bne.s	mt_voice2
	move.l	10(a6),$dff0c0
	move.w	#1,$dff0c4
mt_voice2:
	lea	mt_aud2temp(PC),a6
	cmp.w	#1,14(a6)
	bne.s	mt_voice1
	move.l	10(a6),$dff0b0
	move.w	#1,$dff0b4
mt_voice1:
	lea	mt_aud1temp(PC),a6
	cmp.w	#1,14(a6)
	bne.s	mt_voice0
	move.l	10(a6),$dff0a0
	move.w	#1,$dff0a4
mt_voice0:
	move.l	mt_partnote(PC),d0
	add.l	#$10,d0
	move.l	d0,mt_partnote
	cmp.l	#$400,d0
	bne.s	mt_stop
mt_higher:
	clr.l	mt_partnote
	addq.l	#1,mt_partnrplay
	moveq	#0,d0
	move.w	mt_maxpart(PC),d0
	move.l	mt_partnrplay(PC),d1
	cmp.l	d0,d1
	bne.s	mt_stop
	clr.l	mt_partnrplay
mt_stop:tst.w	mt_status
	beq.s	mt_stop2
	clr.w	mt_status
	bra.s	mt_higher
mt_stop2:
	rts

mt_playit:
	move.l	(a0,d1.l),(a6)
	addq.l	#4,d1
	moveq	#0,d2
	move.b	2(a6),d2
	and.b	#$f0,d2
	lsr.b	#4,d2

	move.b	(a6),d0
	and.b	#$f0,d0
	or.b	d0,d2
	tst.b	d2
	beq.s	mt_nosamplechange

	moveq	#0,d3
	lea	mt_samples(PC),a1
	move.l	d2,d4
	asl.l	#2,d2
	mulu	#$1e,d4
	move.l	(a1,d2),4(a6)
	move.w	(a3,d4.l),8(a6)
	move.w	2(a3,d4.l),18(a6)
	move.w	4(a3,d4.l),d3
	tst.w	d3
	beq.s	mt_displace
	move.l	4(a6),d2
	add.l	d3,d2
	move.l	d2,4(a6)
	move.l	d2,10(a6)
	move.w	6(a3,d4.l),8(a6)
	move.w	6(a3,d4.l),14(a6)
	move.w	18(a6),8(a5)
	bra.s	mt_nosamplechange

mt_displace:
	move.l	4(a6),d2
	add.l	d3,d2
	move.l	d2,10(a6)
	move.w	6(a3,d4.l),14(a6)
	move.w	18(a6),8(a5)
mt_nosamplechange:
	move.w	(a6),d0
	and.w	#$fff,d0
	tst.w	d0
	beq.s	mt_retrout
	move.w	(a6),16(a6)
	move.w	20(a6),$dff096
	move.l	4(a6),(a5)
	move.w	8(a6),4(a5)
	move.w	(a6),d0
	and.w	#$fff,d0
	move.w	d0,6(a5)
	move.w	20(a6),d0
	or.w	d0,mt_dmacon

mt_retrout:
	tst.w	(a6)
	beq.s	mt_nonewper
	move.w	(a6),22(a6)

mt_nonewper:
	move.b	2(a6),d0
	and.b	#$0f,d0
	cmp.b	#$0b,d0
	beq.s	mt_posjmp
	cmp.b	#$0c,d0
	beq.s	mt_setvol
	cmp.b	#$0d,d0
	beq.s	mt_break
	cmp.b	#$0e,d0
	beq.s	mt_setfil
	cmp.b	#$0f,d0
	beq.s	mt_setspeed
	rts

mt_posjmp:
	not.w	mt_status
	moveq	#0,d0
	move.b	3(a6),d0
	subq.b	#1,d0
	move.l	d0,mt_partnrplay
	rts

mt_setvol:
	move.b	3(a6),8(a5)
	rts

mt_break:
	not.w	mt_status
	rts

mt_setfil:
	moveq	#0,d0
	move.b	3(a6),d0
	and.b	#1,d0
	rol.b	#1,d0
	and.b	#$fd,$bfe001
	or.b	d0,$bfe001
	rts

mt_setspeed:
	move.b	3(a6),d0
	and.b	#$0f,d0
	beq.s	mt_back
	clr.w	mt_counter
	move.b	d0,mt_cool+3
mt_back:rts

mt_aud1temp:
	blk.w	10,0
	dc.w	1
	blk.w	2,0
mt_aud2temp:
	blk.w	10,0
	dc.w	2
	blk.w	2,0
mt_aud3temp:
	blk.w	10,0
	dc.w	4
	blk.w	2,0
mt_aud4temp:
	blk.w	10,0
	dc.w	8
	blk.w	2,0

mt_partnote:	dc.l	0
mt_partnrplay:	dc.l	0
mt_counter:	dc.w	0
mt_partpoint:	dc.l	0
mt_samples:	dc.l	0
mt_sample1:	blk.l	31,0
mt_maxpart:	dc.w	0
mt_dmacon:	dc.w	0
mt_status:	dc.w	0

mt_arpeggio:
	dc.w $0358,$0328,$02fa,$02d0,$02a6,$0280,$025c
	dc.w $023a,$021a,$01fc,$01e0,$01c5,$01ac,$0194,$017d
	dc.w $0168,$0153,$0140,$012e,$011d,$010d,$00fe,$00f0
	dc.w $00e2,$00d6,$00ca,$00be,$00b4,$00aa,$00a0,$0097
	dc.w $008f,$0087,$007f,$0078,$0071,$0000,$0000,$0000

COPER:
dc.l	$01006600,$01020000,$01800000
DC.L	$01900000,$01920FFF,$01940AAF,$0196055F,$0198000F
DC.L	$019A000A,$019C0005,$019E0000

COPPS1:dc.l	$00e00000,$00e20000 ; pointeurs sur bt1
COPPS2:dc.l	$00e80000,$00ea0000
COPPS3:dc.l	$00f00000,$00f20000

coppD1:dc.l	$00e40000,$00E60000
COPPD2:dc.l	$00eC0000,$00EE0000
COPPD3:dc.l	$00F40000,$00F60000


DC.L	$0184048F,$0186004F
dc.l	$0108000c,$010a000c

dc.l	$2c0ffffe,$01820000 ; degrade du petit scroll
dc.l	$2d0ffffe,$01820403 ; celui ci ne bouge pas
dc.l	$2e0ffffe,$01820504
dc.l	$2f0ffffe,$01820604
dc.l	$300ffffe,$01820705
dc.l	$310ffffe,$01820805
dc.l	$320ffffe,$01820906
dc.l	$330ffffe,$01820a06
dc.l	$340ffffe,$01820b07
dc.l	$350ffffe,$01820c07
dc.l	$360ffffe,$01820d08
dc.l	$370ffffe,$01820e08
dc.l	$380ffffe,$01820000
;dc.l	$390ffffe,$01820d09
;dc.l	$3a0ffffe,$01820b0a
;dc.l	$3b0ffffe,$0182090a
dc.l	$3c01fffe
DC.L	$01800000,$01820000,$01840000,$01860000,$01880000,$018A0000
DC.L	$018E0000

DC.L	$4501FFFE
COPP:DC.L	$00E00000,$00E20000
COPP1:DC.L	$00E80000,$00EA0000
	dc.l	$01080000,$010a0000
DC.L	$01800000,$0182000F,$01840005,$01860000,$01880000,$018A0000
DC.L	$018E0000



deg:
blk.b	8*[152+33+10],00


COPPS1B:dc.l	$00e00000,$00e20000 ; pointeurs sur bt1
COPPS2B:dc.l	$00e80000,$00ea0000
COPPS3B:dc.l	$00f00000,$00f20000

DC.L	$01840000

dc.l	$1401FFFE
DC.L	$01820000

dc.l	$1501FFFE
coppSS1:
dc.l	$00e00000,$00e20000

dc.l	$0108000c,$010a000c
DC.L	$01820000

dc.l	$16E1FFFE,$0182000F
dc.l	$17E1FFFE,$0182000E
dc.l	$18E1FFFE,$0182000D

dc.l	$2001FFFE,$0182000D
DC.L	$01840000,$01860000,$01880000,$018A0000,$018C0000,$018E0000
DC.L	$01920000,$01940000,$01960000,$01980000
dc.l	$21E1FFFE,$0182000E
dc.l	$22E1FFFE,$0182000F




DC.L	$009C8010
dc.l	$fffffffe

texte:
	dc.b '_HI_DINO___VOILA_JE_SAVAIS_PAS_KOI_FAIRE_ALORS____'
	dc.b '_J_ESPERE_KE_CA_TE_PLAIRA_ET_TU_POURRAS_FER_DES_COMPILS_'
	DC.B '_ENCORE_PLUS_BEAUCOUP_________JE_TE_KIT_MON_BON_AMI_'
	DC.B '_ORIENS_SIGNED_AUF__________________________________'
	DC.B '_JE_VAIS_AU_DODO_ET_DEMAIN_JE_T_ENVOIS_TOUT_CA________'
	DC.B '______________________________________________________'

fin_texte:
even
cptr:	dc.l	texte
nb:	dc.b	0
even
				
;il faut que la music soit bien un 2.4 modules et qu'il y ait assez 
;de place de reserve !!! sinon ca plante. (instruments bizare)
;elle sera ensuite codee et inrippable bien sur.
;>extern "chartoo",chars
;>extern "nomdelazic",mt_data
;
; ** BON COURAGE DINO. ** (et encore ce n'est que le debut !!!!!)
;

BLANK:BLK.B	10240,$00

bt1a:
bt1b=BT1A+8000
BT2a=BT1b+8000
BT2B=BT2a+8000
MASK=BT2B+8000	
CHARS=MASK+7000
BT1=CHARS+3840
BOBFOND=BT1+10000
MT_DATA=BOBFOND+30720
FIN=MT_DATA+22000	;< CE CHIFFRE EST LA TAILLE DU MODULES

>extern "font",chars
>EXTERN "MASK",MASK
>EXTERN "BOBFOND",BOBFOND

